local callbacks = {}
local _M = {}

local Java = _G.Java
local package = _G.package

local argth = require("scripts.argth")
local check_value = argth.check_value
local opt_value = argth.opt_value

package["1func"] = package["1func"] or {}
package["1func"].callbacks = callbacks

local function registerCallback(...)
    local name = check_value(1, "string", ...)
    local func = check_value(2, "function", ...)
    callbacks[name] = func
end

local function getCallbackByName(...)
    local name = check_value(1, "string", ...)
    return callbacks[name]
end

_M.registerCallback = registerCallback
_M.getCallbackByName = getCallbackByName

return _M