local _M = {}
local customformats = {}

local Java = _G.Java

local argth = require("scripts.argth")
local check_value = argth.check_value
local opt_value = argth.opt_value

local package = _G.package
local _1f = _1func

package["1func"] = package["1func"] or {}
package["1func"].customformats = customformats

local customFormatChooser = _1f:getCustomFormatChooser()

local function getModuleNames()
    local ml = _1f:getModuleList("scripts.colorpicker.customformats", false)
    local ret = {}
    for i = 0, ml:size()-1 do
        ret[i + 1] = ml:get(i)
    end
    return ret
end

local function registerCustomFormat(cfmt)
    if type(cfmt)=="table" and type(cfmt.name) == "string" then
        customformats[#customformats + 1] = cfmt
        customFormatChooser:addItem(cfmt.name)
        return true
    else
        return false
    end
end

local function getSelectedFormat()
    local cst = customformats[customFormatChooser:getSelectedIndex()+1]
    cst = cst or {}
    cst.formats = cst.formats or {}
    return cst.formats
end

local function getSelectedFormatName()
    local cst = customformats[customFormatChooser:getSelectedIndex()+1]
    cst = cst or {}
    cst.name = cst.name
    return cst.name
end

local function getSelectedFormatDescription()
    local cst = customformats[customFormatChooser:getSelectedIndex()+1]
    cst = cst or {}
    cst.description = cst.description
    return cst.description
end

_M.getModuleNames = getModuleNames
_M.registerCustomFormat = registerCustomFormat
_M.getSelectedFormat = getSelectedFormat
_M.getSelectedFormatName = getSelectedFormatName
_M.getSelectedFormatDescription = getSelectedFormatDescription

return _M


